#include <iostream>
#include <math.h>
#include <stdio.h>
#include <fstream>
#include <string>
#include <cstdlib>
#include <cctype>
#include <sstream>

using namespace std;

double fac(double);//factorial

//Read Input
//Per line:
////Search config for identifier
////Read config data for identifier
////-Number of atoms
////-Sum formula
////For each atom type read from isoconfig:
//////-weight
//////-Number of possible isotopes
//////-Isotopic distribution
////Calculate exspected number of peaks
////Read experimental peaks
////For each atom type:
//////Create correction matrix
//////Apply matrix to peak vector
//////Create output vector
////Create new output line with vector entries from all experiments

//////Customizationpoint <------- Look for this to change hard coded limits


int main(int argc, char* argv[]){
	ofstream errorlog; errorlog.open("error.log");
	int iserror=0;
	if (argc != 4 and argc != 6){
		cout << "Usage: ./corrector10.exe [Optional: -igz [integer]] inputfile outputfile1(raw data) outputfile2(atom percentages) \n";
		errorlog << "Please state the options, the name of your input file and two output files (raw data and atom percentages)!\n";
		errorlog.close();
		exit(0);
	}
	int ign_zeroes=0;
	if (argc == 6){
		string checkstring=argv[1];
		if (checkstring!="-igz"){
			cout << "Usage: ./corrector10.exe [Optional: -igz [integer]] inputfile outputfile1(raw data) outputfile2(atom percentages) \n";
			errorlog << "Please state the options, the name of your input file and two output files (raw data and atom percentages)!\n";
			errorlog.close();
			exit(0);
		}
		else ign_zeroes=atoi(argv[2]);
	}
	//Variable deklaration
	string ident;
	string read_ident = "Erdbeerkuchen";
	int fragments=15;//MaxFragmentsPerIdentifier//////Customizationpoint
	int N_types=20;//MaxAtomTypesPerIdentifier//////Customizationpoint
	string configstring[fragments*N_types];//Atom type names
	int atome[fragments*N_types];//atoms per atom type
	int lower[fragments];//lower fragment mass
	int upper[fragments];//Upper fragment mass
	int more[fragments];//surplus peaks counted
	int N_A[fragments];//Number of atoms in Fragment
	int N_T[fragments];//Number of Atom types
	int i_n[fragments*N_types];//Here are the number of exspected peaks for each atom type (read from isoconfig)
	double i_m[fragments*N_types*10];//and the natural abundance (form isoconfig)
	int basismassen[fragments*N_types];//Here weigth per atom type
	int n_isomere[fragments];//How many peaks are to be exspected in a spectrum? -> Matrix lines maximum!
	double inten[510*500];//Data points (+10 Buffer lines)*Runs//////Customizationpoint
	int iso[100*50*10];//100 Mass possibilities * 50 Combination possibilities * 10 Combination digits = atom types!!//i.E. 101 for 16O18O and 020 for 17O_2. The big Combinator!!!////k_max+1 is used as counter
	double c[400*400];//Correction matrix for atom type j
	ifstream inf;
	ofstream outf;
	ofstream outf2;
	if (argc == 4){
		inf.open(argv[1]);//Input file
		outf.open(argv[2]);//output file
		outf2.open(argv[3]);//output file 2 (atom %)
	}
	if (argc == 6){
		inf.open(argv[3]);//Input file
		outf.open(argv[4]);//output file
		outf2.open(argv[5]);//output file 2 (atom %)
	}
	ifstream config;//config file
	ifstream isotopes;//isotope date file
	config.open("corrconfig.cfg");
	if (!config) {
		cout << "No corrconfig.cfg found in working directory!\n";
		errorlog << "No corrconfig.cfg found in working directory!\n";
		errorlog.close();
		exit(0);
	}
	config.close();
	isotopes.open("isoconfig.cfg");
	if (!isotopes) {
		cout << "No isoconfig.cfg found in working directory!\n";
		errorlog << "No isoconfig.cfg found in working directory!\n";
		errorlog.close();
		exit(0);
	}
	isotopes.close();
	cout << "Corrector 1.6: By Jan Gtze, University of Potsdam\nComplaints and praises are to be sent to jgoetze@uni-potsdam.de\nProgram limitations\n 1. Fragments per identifier are limited to " << fragments << " and number of atom types limited to 10.\n 2. Program is very strict with input format.\n 3. Range of mass is set to (minimum mass in data)+500.\n 4. First line in input must not exceed 1024*1024 characters.\n######################\nAvailable options:\n-igz [integer] : will ignore up to [integer] empty or negative mass peaks for the enrichment calculation (atom percentages) after the first positive mass peak. Useful for high enrichment experiments with a leading peak followed by a series of empty peaks. Default is 0.\n######################\nEnjoy!\n";
	int zeile = 3;
	int runs=-2;
	char buffer1MB[1024*1024];
	int kombinationen[1000];//Counter for borders of matrix element sums
	//Input & Processing
	time_t rawtime;
	time (&rawtime);
	outf << "This file is isotope corrected by corrector.exe v1.6 at " << ctime (&rawtime);
	outf2 << "This file was created by corrector.exe v1.6 at " << ctime (&rawtime);
	inf.getline(buffer1MB, 1024*1024, '\n');
	stringstream first;
	first.str(buffer1MB);
	first >> ident;
	while (!first.eof()){//Get Experiments
		runs++;
		outf << ident << " ";
		outf2 << ident << " ";
		first >> ident;
	}
	if (runs>500){//Error for too many runs
			cout << "Please do not state more than 500 runs per input file.";
			errorlog << "Please do not state more than 500 runs per input file.";
			inf.close();
			outf.close();
			outf2.close();
			errorlog.close();
			exit(0);
	}
	outf << "\n";
	outf2 << "\n";
	inf >> ident;//Read first string, should be an identifier
	while(! inf.eof()){//Loop until end of input. Main process
		config.open("corrconfig.cfg");//Open config. Must be done every loop.
		int ic=0;//number of fragments (sub-identifiers, mass ranges) per identifier
		while ( read_ident != "//EndofCommentary//" and ! config.eof())//Skip comment
			config >> read_ident;
		while ( ident != read_ident and ! config.eof())//Look for identifier in config
			config >> read_ident;
		if (ident != read_ident){//Error if identifier not found
			errorlog << "Identifier in input line " << zeile << " was not found in the corrconfig.cfg! The line has been ignored.\n";
			iserror=1;
			for (int i=0; i<runs+2; i++)//Skip the line
				inf >> ident;
			zeile++;
			config.close();
			continue;
		}
//Read config entries
		while (ident == read_ident and ic<fragments and !config.eof()){
			config >> lower[ic]; //Smallest fragment
			config >> upper[ic]; //Largest fragment
			config >> more[ic]; //Additional peaks
			config >> N_A[ic]; //Number of atoms
			int sum_A = 0;
			int n_atomtypen = 0;
			while (N_A[ic] != sum_A){//Read atoms
				config >> configstring[ic*N_types+n_atomtypen];//Type
				config >> atome[ic*N_types+n_atomtypen];//Amount
				sum_A += atome[ic*N_types+n_atomtypen];
				n_atomtypen++;
				if (sum_A > N_A[ic]){//Error if atoms defined do not match overall sum in fragment
					cout << "Total number of atoms for Identifier " << read_ident << " with mass " << lower[ic] << " not consistent with numbers of each atom type in corrconfig.cfg!\n";
					errorlog << "Total number of atoms for Identifier " << read_ident << " with mass " << lower[ic] << " not consistent with numbers of each atom type in corrconfig.cfg!\n";
					inf.close();
					outf.close();
					outf2.close();
					config.close();
					errorlog.close();
					exit(0);
				}
			}
			N_T[ic]=n_atomtypen;//Number of atom types
			ic++;
			config >> read_ident;
		}
		if (ic == fragments){
			errorlog << "There may have been more than " << fragments << " known fragments for " << ident << " which have been ignored due to program limitations.\n Please ask your developer to increase this limit or split the corrconfig.cfg!\n";
			iserror=1;
		}
		config.close();//Close config. Must be done every run.
//Combine config entries with isotopes, to gain matrix dimensions
		for (int j=0; j<ic; j++){
			//clog << "j1 =" << j << "\n";
			for (int i=0; i<N_T[j]; i++){
				isotopes.open("isoconfig.cfg");
				read_ident = "Erdbeerkuchen";//Variable recycling
				while(! (isotopes.eof() or read_ident == configstring[j*N_types+i]))
					isotopes >> read_ident;
				if (configstring[j*N_types+i] != read_ident){//Error if atom type not found
					cout << "Atom type " << configstring[j*N_types+i] << " was not found in isoconfig.cfg!\n";
					errorlog << "Atom type " << configstring[j*N_types+i] << " was not found in isoconfig.cfg!\n";
					inf.close();
					outf.close();
					outf2.close();
					isotopes.close();
					errorlog.close();
					exit(0);
				}
				isotopes >> basismassen[j*N_types+i];
				isotopes >> i_n[j*N_types+i];
				for (int k = 0; k<i_n[j*N_types+i]; k++)
					isotopes >> i_m[j*N_types*10+i*10+k];
				isotopes.close();
			}
		}
		for (int j=0; j<ic; j++){
			//clog << "j2 =" << j << "\n";
			n_isomere[j]=0;
			for (int i=0; i<N_T[j]; i++)
				n_isomere[j] += (i_n[j*N_types+i]-1)*atome[j*N_types+i];
			n_isomere[j] += 1;//Finished, these are maximum matrix lines
		}
//////////////All data of the identifier have been collected, now input until reading of new identifier
		read_ident = ident;
		int line = 0;
		int masse = 0;
		inf >> inten[0];//Read mass of first identifier line
		for (int i=0; i<runs; i++)
			inf >> inten[line*500+i+1];//Read data of first identifier line
		inf >> ident;
		zeile++;
		//clog << "Bing!\n";
		while (ident == read_ident and !inf.eof()){
			//clog << line << "\n";
			inf >> masse;
			if (masse == 0){
				cout << "Error in input, probably values (zeros?) missing!\n";
				errorlog << "Error in input, probably values (zeros?) missing!\n";
				inf.close();
				outf.close();
				outf2.close();
				errorlog.close();
				exit(0);
			}
			double q=1.;
			int r=1;
			//clog << "Ident: " << read_ident << "Masse: " << masse << " inten[line*500]+q: " << inten[line*500]+q << " Zeile: " << zeile << "\n";
			while (masse != inten[line*500]+q){//If masses are missing, postulate them and set them to zero.
				inten[(line+r)*500] = inten[line*500]+q;
				for (int i=0; i<runs; i++)
					inten[(line+r)*500+i+1]=0.;
				q++;
				r++;
				if (masse < inten[line*500]+q){
					cout << "Error in input line " << zeile << ", probably doubled or unsorted masses!\n";
					errorlog << "Error in input line " << zeile << ", probably doubled or unsorted masses!\n";
					inf.close();
					outf.close();
					outf2.close();
					errorlog.close();
					exit(0);
				}
				//clog << r << " " << q << "\n";
			}
			line += r;//Increase ine counter by postulated masses
			inten[line*500] = masse;//Define experimental mass
			for (int i=0; i<runs; i++)
				inf >> inten[line*500+i+1];//Define experimental peaks
			inf >> ident;
			zeile++;//Line counter for error messages
		}
		//clog << "Zing!\n";
		for (int j=0; j<10; j++){//add ten lines to the spectrum as buffer
			line++;
			masse++;
			inten[line*500]=masse;
			for (int i=0; i<runs; i++)
				inten[line*500+i+1]=0.;//Define experimental peaks
		}
		//clog << "Ding!\n";
/////Intensity correction section
		int r=0;
		while (r<=line){
			//clog << "r= "<< r << " line = " << line <<"\n";
			int s=0;
			while(inten[r*500]!=lower[s] and s<ic)
				s++;
			if (s==ic)
				r++;
			else{
				//clog << "s=" << s << "\n";
				for (int j =0; j<N_T[s]-1; j++){//Until n_atomtypen-1, last type will be neglected.
					//clog << "j=" << j << "\n";
					if (atome[s*N_types+j]==0) continue;
					if (i_n[s*N_types+j] != 1){
						int capacity = i_n[s*N_types+j]-1;
						////Matrix definition
						////Combination calculation, to define borders (summands per matrix element)
						for (int i = 0; i<=atome[s*N_types+j]*capacity; i++) kombinationen[i]=0;//for each mass Kombinationen[i] is set to zero
						//The big combinator! All combinations are here.
						for (int i = 0; i<i_n[s*N_types+j]; i++) iso[10+i]=0;//The test element is always iso[10+i]. Set everything to 0...
						while (iso[10+i_n[s*N_types+j]-1] < atome[s*N_types+j]){//quits at maximum possible isotopologue (which has already been recorded)
							//Create new test element
							int sum = 0;
							while (sum != atome[s*N_types+j]){//As the sum is correct, a new combination is found
								iso[10]+=atome[s*N_types+j];// Count each number. It is like counting in the basis of atoms[j]+1.
								int over = 0;
								if (iso[10]>atome[s*N_types+j])
									over = 1;
								while (over != 0){
									iso[10+over-1]-=(atome[s*N_types+j]+1);
									iso[10+over]++;
									if (iso[10+over]>atome[s*N_types+j])
										over++;
									else
										over=0;
								}
								sum = 0;
								for (int k = 0; k<i_n[s*N_types+j]; k++)//Sum up
									sum+=iso[10+k];
							}//Element found
							int mass = 0;
							for (int k = 0; k<i_n[s*N_types+j]; k++) mass+=iso[10+k]*k;//Which mass has the new element
							for (int k = 0; k<i_n[s*N_types+j]; k++) iso[mass*500+(kombinationen[mass])*10+k]=iso[10+k];//Test element is added to it's mass entry.
							//clog << iso[mass*500+(kombinationen[mass])*10+k] << " ";}
							kombinationen[mass]++;//Combination counter for that mass is increased
							//clog << "masscount for mass " << mass << ": " << kombinationen[mass] << "\n";
						}
						for (int i = 0; i<n_isomere[s]; i++){//Matrix lines
							//clog << kombinationen[i] << " ";
							//Elemente = 0 or known from previous lines
							for (int k=0; k<n_isomere[s]; k++){//zeroes
								c[i*400+k]=0.;//Set all to zero, escpecially the first line, that helps a lot
								if (k!=0 and i!=0)//Except for first line and first column everything is being copied
									c[i*400+k]=c[(i-1)*400+k-1];//Overwrite
							}
							//New matrix elements, only first elements in every column. Others see above.
							if (i<=(atome[s*N_types+j]*capacity)){
								for (int p = 0; p<kombinationen[i];p++){
									double prod_abun = 1.;
									int frq_abun = 0;
									for (int m=0; m<i_n[s*N_types+j]; m++)
										prod_abun *= pow(i_m[s*N_types*10+j*10+m],iso[i*500+p*10+m])/fac((double)iso[i*500+p*10+m]);
									//if (i<=3) {
									//	clog << "prod_abun: "<< prod_abun << "\n";
									//	clog << "m: ";
									//}
									for (int m=0; m<i_n[s*N_types+j]; m++){
										//if (i<=3) clog << m << " iso: " << iso[i*500+p*10+m] << " ";
										frq_abun += iso[i*500+p*10+m];
									}
									//if (i<=3) clog << "\nfrq_abun: " << frq_abun << "\n";
									c[i*400]+=fac(frq_abun)*prod_abun;
									//if (i<=3) clog << "c[i*400]: " << c[i*400] << "\n";
								}
							}
						//for (int k=0; k<n_isomere[s]; k++){ //Matrix output
						//	if (i<=3) clog << c[i*400+k] << " ";}
						//	if (i<=3) clog << "\n";
						}
						//Correction process!
						for (int l=1; l<=runs; l++){//For each Run
							for(int i = 0; i <= (upper[s]+more[s]-lower[s]); i++){//From above
								//if (l==N_types) clog << "Alt: " << inten[(r+i)*500+l] << " Neu: " << inten[(r+i)*500+l] << "/" << c[i*400+i] << "=" << inten[(r+i)*500+l]/c[i*400+i] << "\n";
								inten[(r+i)*500+l] = inten[(r+i)*500+l]/c[i*400+i];
								if (i!=0 and inten[(r+i)*500+l] != 0.){
									for (int k=0;k<i;k++){
									//if (l==N_types) clog << "Altnotfirst: " << inten[(r+i)*500+l] << " Neunotfirst: " << inten[(r+i)*500+l] << "-" << inten[(r+k)*500+l] << "*" << c[i*400+k] << "/" << c[i*400+i] << "=" << inten[(r+i)*500+l]-(inten[(r+k)*500+l]*c[i*400+k]/c[i*400+i]) << "\n";
										inten[(r+i)*500+l] -= inten[(r+k)*500+l]*c[i*400+k]/c[i*400+i]; // inten[i]/MatrixZeile[i] -> old I[i] is not needed and gets overwritten with the new
									}
									if (inten[(r+i)*500+l] < 0.) inten[(r+i)*500+l]=0.;//Cosmetics
								}
							}
						}
					}
				}
				for(int i=0; i <= (upper[s]+more[s]-lower[s]); i++){
					outf << read_ident;
					for (int l=0; l<=runs; l++)//For each run
						outf << " " << inten[(i+r)*500+l]; //output of corrected intensities
					outf << "\n";
				}
				//Begin output of atom percentages
				outf2 << read_ident;
				//Begin look for N from corrconfig
				ifstream config2;
				config2.open("corrconfig.cfg");
				string dump="";
				while (dump!=read_ident) config2 >> dump;
				for (int i=0; i<s; i++) {//Skip already calculated masses of the identifier
					char t=0;
					while (t != '\n') config2.get(t);
					config2 >> dump;
				}
				config2 >> dump;
				outf2 << " " << dump;
				config2 >> dump >> dump;
				double bla;//total fragment atoms
				config2 >> bla;
				double zeugs;//Atoms per type
				double sum_zeugs=0.;
				while (sum_zeugs != bla){
					config2 >> dump;
					config2 >> zeugs;
					sum_zeugs+=zeugs;
				}//zeugs is now amount of labelable atoms
				config2.close();
				//End look for N from corrconfig
				for (int l=1; l<=runs; l++){//For each run
					int start=0;
					double gesamtint=0.;
					double mod_int=0.;
					double isoszahl=0.;
					for(int i=0; i <= (upper[s]+more[s]-lower[s]); i++){//For all requested peaks
						if ((inten[(i+r)*500+l] <= 0) and (start==1)) break;//Break if below zero after valid value.
						if ((inten[(i+r)*500+l] <= 0) and (start>1)) {
							start--;
							iserror=1;
							errorlog << "Found a zero or lower value in at mass " << lower[s]+i << " for identifier " << read_ident << " in run " << l << ". The value was ignored due to igz > 0.\n";
						}
						if ((inten[(i+r)*500+l] > 0) and (start==0)) start=(1+ign_zeroes); //Value is valid
						if (start>=1) {
							gesamtint+=inten[(i+r)*500+l];
							mod_int+=inten[(i+r)*500+l]*isoszahl;
						}
						isoszahl++;
					}
					if (gesamtint != 0.) outf2 << " " << mod_int*100./(gesamtint*zeugs) << "%";//Output of atom percentages
					else outf2 << " NA";
				}
				outf2 << "\n";
				//Ende output of atom percentages
				r++;
			}
		}
	}
	if (iserror==1 and ign_zeroes==0) cout << "There were uncritical errors! Please look up error.log for details.\n";
	else if (iserror==1 and ign_zeroes>0) cout << "There were uncritical errors or values ignored due to igz > 0! Please look up error.log for details.\n";
	else cout << "No errors occured, your error.log should be empty.\n";
	cout << "Reached end of input file. Thank you for using Corrector v1.6!\n";
	inf.close();
	outf.close();
	outf2.close();
}

double fac(double n){
	if (n==0.)
		n=1.;
	else
		n*=fac(n-1);
	return(n);
}
